/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef CAIO_H
#define CAIO_H

#include <aio.h>
#include <stddef.h>

struct caio_open
{
    const char *path;
    int flags;
    uid_t uid;
    gid_t gid;
};

struct caio *caio_open(const struct caio_open *op, const struct aio_done *d);
int caio_set_caches(struct caio *a, size_t n);
int caio_read(struct caio *a, void *buf, size_t n, const struct aio_done *d);
int caio_write(struct caio *a, const void *buf, size_t n,
    const struct aio_done *d);
int caio_seek(struct caio *a, off_t offset);
int caio_tell(const struct caio *a, off_t *offset);
int caio_eof(const struct caio *a);
int caio_close(struct caio *a);

#endif
